/* DEFS: message receiverMsg{
char buf[];
}
;
 */
#ifndef CK_TEMPLATES_ONLY
void *CMessage_receiverMsg::operator new(size_t s){
  return receiverMsg::alloc(__idx, s, 0, 0);
}
void *CMessage_receiverMsg::operator new(size_t s, int* sz){
  return receiverMsg::alloc(__idx, s, sz, 0);
}
void *CMessage_receiverMsg::operator new(size_t s, int* sz,const int pb){
  return receiverMsg::alloc(__idx, s, sz, pb);
}
void *CMessage_receiverMsg::operator new(size_t s, int sz0) {
  int sizes[1];
  sizes[0] = sz0;
  return receiverMsg::alloc(__idx, s, sizes, 0);
}
void *CMessage_receiverMsg::operator new(size_t s, int sz0, const int p) {
  int sizes[1];
  sizes[0] = sz0;
  return receiverMsg::alloc(__idx, s, sizes, p);
}
void* CMessage_receiverMsg::alloc(int msgnum, size_t sz, int *sizes, int pb) {
  size_t offsets[2];
  offsets[0] = ALIGN8(sz);
  if(sizes==0)
    offsets[1] = offsets[0];
  else
    offsets[1] = offsets[0] + ALIGN8(sizeof(char)*sizes[0]);
  receiverMsg *newmsg = (receiverMsg *) CkAllocMsg(msgnum, offsets[1], pb);
  newmsg->buf = (char *) ((char *)newmsg + offsets[0]);
  return (void *) newmsg;
}
void CMessage_receiverMsg::dealloc(void *p) {
  CkFreeMsg(p);
}
void* CMessage_receiverMsg::pack(receiverMsg *msg) {
  msg->buf = (char *) ((char *)msg->buf - (char *)msg);
  return (void *) msg;
}
receiverMsg* CMessage_receiverMsg::unpack(void* buf) {
  receiverMsg *msg = (receiverMsg *) buf;
  msg->buf = (char *) ((size_t)msg->buf + (char *)msg);
  return msg;
}
int CMessage_receiverMsg::__idx=0;
#endif

/* DEFS: array receiver: ArrayElement{
receiver(CkMigrateMessage* impl_msg);
receiver(void);
void generic(receiverMsg* impl_msg);
threaded sync void syncSend(receiverMsg* impl_msg);
void ready2go(void);
};
 */
#ifndef CK_TEMPLATES_ONLY
 int CkIndex_receiver::__idx=0;
#endif
#ifndef CK_TEMPLATES_ONLY
/* DEFS: receiver(CkMigrateMessage* impl_msg);
 */

/* DEFS: receiver(void);
 */
void CProxyElement_receiver::insert(int onPE)
{ 
  void *impl_msg = CkAllocSysMsg();
   ckInsert((CkArrayMessage *)impl_msg,CkIndex_receiver::__idx_receiver_void,onPE);
}

/* DEFS: void generic(receiverMsg* impl_msg);
 */
void CProxyElement_receiver::generic(receiverMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_receiver::__idx_generic_receiverMsg,0);
}

/* DEFS: threaded sync void syncSend(receiverMsg* impl_msg);
 */
void CProxyElement_receiver::syncSend(receiverMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  CkFreeSysMsg(ckSendSync(impl_amsg, CkIndex_receiver::__idx_syncSend_receiverMsg));
}

/* DEFS: void ready2go(void);
 */
void CProxyElement_receiver::ready2go(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_receiver::__idx_ready2go_void,0);
}

/* DEFS: receiver(CkMigrateMessage* impl_msg);
 */
 int CkIndex_receiver::__idx_receiver_CkMigrateMessage=0;
void CkIndex_receiver::_call_receiver_CkMigrateMessage(void* impl_msg,receiver * impl_obj)
{
  new (impl_obj) receiver((CkMigrateMessage*)impl_msg);
}

/* DEFS: receiver(void);
 */
CkArrayID CProxy_receiver::ckNew(const CkArrayOptions &opts)
{ 
  void *impl_msg = CkAllocSysMsg();
   return ckCreateArray((CkArrayMessage *)impl_msg,CkIndex_receiver::__idx_receiver_void,opts);
}
CkArrayID CProxy_receiver::ckNew(const int s1)
{ 
  void *impl_msg = CkAllocSysMsg();
   return ckCreateArray((CkArrayMessage *)impl_msg,CkIndex_receiver::__idx_receiver_void,CkArrayOptions(s1));
}
 int CkIndex_receiver::__idx_receiver_void=0;
void CkIndex_receiver::_call_receiver_void(void* impl_msg,receiver * impl_obj)
{
  CkFreeSysMsg(impl_msg);
  new (impl_obj) receiver();
}

/* DEFS: void generic(receiverMsg* impl_msg);
 */
void CProxy_receiver::generic(receiverMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_receiver::__idx_generic_receiverMsg,0);
}
 int CkIndex_receiver::__idx_generic_receiverMsg=0;
void CkIndex_receiver::_call_generic_receiverMsg(void* impl_msg,receiver * impl_obj)
{
  impl_obj->generic((receiverMsg*)impl_msg);
}

/* DEFS: threaded sync void syncSend(receiverMsg* impl_msg);
 */
 int CkIndex_receiver::__idx_syncSend_receiverMsg=0;
void CkIndex_receiver::_call_syncSend_receiverMsg(void* impl_msg,receiver * impl_obj)
{
  CthThread tid = CthCreate((CthVoidFn)_callthr_syncSend_receiverMsg, new CkThrCallArg(impl_msg,impl_obj), 0);
  ((Chare *)impl_obj)->CkAddThreadListeners(tid,impl_msg);
  CthAwaken(tid);
}
void CkIndex_receiver::_callthr_syncSend_receiverMsg(CkThrCallArg *impl_arg)
{
  void *impl_msg = impl_arg->msg;
  receiver *impl_obj = (receiver *) impl_arg->obj;
  delete impl_arg;
  int impl_ref = CkGetRefNum(impl_msg), impl_src = CkGetSrcPe(impl_msg);
  void *impl_retMsg=CkAllocSysMsg();
    impl_obj->syncSend((receiverMsg*)impl_msg);
  CkSendToFuture(impl_ref, impl_retMsg, impl_src);
}

/* DEFS: void ready2go(void);
 */
void CProxy_receiver::ready2go(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_receiver::__idx_ready2go_void,0);
}
 int CkIndex_receiver::__idx_ready2go_void=0;
void CkIndex_receiver::_call_ready2go_void(void* impl_msg,receiver * impl_obj)
{
  CkFreeSysMsg(impl_msg);
  impl_obj->ready2go();
}

/* DEFS: receiver(CkMigrateMessage* impl_msg);
 */

/* DEFS: receiver(void);
 */

/* DEFS: void generic(receiverMsg* impl_msg);
 */
void CProxySection_receiver::generic(receiverMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_receiver::__idx_generic_receiverMsg,0);
}

/* DEFS: threaded sync void syncSend(receiverMsg* impl_msg);
 */

/* DEFS: void ready2go(void);
 */
void CProxySection_receiver::ready2go(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_receiver::__idx_ready2go_void,0);
}

#endif /*CK_TEMPLATES_ONLY*/
#ifndef CK_TEMPLATES_ONLY
void CkIndex_receiver::__register(const char *s, size_t size) {
  __idx = CkRegisterChare(s, size, TypeArray);
  CkRegisterBase(__idx, CkIndex_ArrayElement::__idx);
// REG: receiver(CkMigrateMessage* impl_msg);
  __idx_receiver_CkMigrateMessage = CkRegisterEp("receiver(CkMigrateMessage* impl_msg)",
     (CkCallFnPtr)_call_receiver_CkMigrateMessage, 0, __idx, 0);
  CkRegisterMigCtor(__idx, __idx_receiver_CkMigrateMessage);

// REG: receiver(void);
  __idx_receiver_void = CkRegisterEp("receiver(void)",
     (CkCallFnPtr)_call_receiver_void, 0, __idx, 0);
  CkRegisterDefaultCtor(__idx, __idx_receiver_void);

// REG: void generic(receiverMsg* impl_msg);
  __idx_generic_receiverMsg = CkRegisterEp("generic(receiverMsg* impl_msg)",
     (CkCallFnPtr)_call_generic_receiverMsg, CMessage_receiverMsg::__idx, __idx, 0);

// REG: threaded sync void syncSend(receiverMsg* impl_msg);
  __idx_syncSend_receiverMsg = CkRegisterEp("syncSend(receiverMsg* impl_msg)",
     (CkCallFnPtr)_call_syncSend_receiverMsg, CMessage_receiverMsg::__idx, __idx, 0);

// REG: void ready2go(void);
  __idx_ready2go_void = CkRegisterEp("ready2go(void)",
     (CkCallFnPtr)_call_ready2go_void, 0, __idx, 0);

}
#endif

#ifndef CK_TEMPLATES_ONLY
void _registerreceiver(void)
{
  static int _done = 0; if(_done) return; _done = 1;
/* REG: message receiverMsg{
char buf[];
}
;
*/
CMessage_receiverMsg::__register("receiverMsg", sizeof(receiverMsg),(CkPackFnPtr) receiverMsg::pack,(CkUnpackFnPtr) receiverMsg::unpack);

/* REG: array receiver: ArrayElement{
receiver(CkMigrateMessage* impl_msg);
receiver(void);
void generic(receiverMsg* impl_msg);
threaded sync void syncSend(receiverMsg* impl_msg);
void ready2go(void);
};
*/
  CkIndex_receiver::__register("receiver", sizeof(receiver));

}
#endif
